/*
  SDLǤե

    2002/ 1/27  
*/

#include "SDL.h"
#include <stdio.h>

Uint32 *backbuf,*buttocks,*hand,hx,hy;
SDL_Rect rectFore,rectBack,rectHand,rectTe;
SDL_Surface *window,*back,*te;

int loadBMP(char *fn,Uint32 **pixels) {

	Uint8 *buf;
	int size,width,height,length,offset,i,j,p;

	FILE *fp=fopen(fn,"rb");

	fseek(fp,0,SEEK_END);
	size=ftell(fp)+1;
	rewind(fp);

	if (size<54) {

		fclose(fp);
		return 0;

	}

	buf=(Uint8 *)malloc(size);

	fread(buf,1,size,fp);
	fclose(fp);

	offset=*((int *)(buf+10));
	width=*((int *)(buf+18));
	height=*((int *)(buf+22));
	*pixels=(Uint32 *)malloc(width*height*4);

	if (width % 4==0)
		length=width*3;
	else
		length=width*3+(4-(width*3)%4);

	for (i=0;i<height;i++)
		for (j=0;j<width;j++) {

			p=j*3+(height-i-1)*length+offset;
			(*pixels)[j+i*width]=buf[p]+buf[p+1]*256+buf[p+2]*65536;

		}

	return width*height;

}

void draw() {

	memcpy(backbuf,buttocks,450*300*4);
	SDL_BlitSurface(te,&rectTe,back,&rectHand);

	SDL_BlitSurface(back,&rectBack,window,&rectFore);

	SDL_UpdateRect(window,0,0,0,0);

}

int main(int arg,char *argv) {

	int quite=0,i;
	SDL_Event e;

	if (SDL_Init(SDL_INIT_VIDEO)!=0)
		exit(1);

	window=SDL_SetVideoMode(452,302,32,SDL_SWSURFACE);

	loadBMP("osiri.bmp",&buttocks);
	loadBMP("hand.bmp",&hand);

	backbuf=(Uint32 *)malloc(450*300*4);
	back=SDL_CreateRGBSurfaceFrom((void *)backbuf,450,300,32,450*4,
	       0x00ff0000,0x0000ff00,0x000000ff,0);

	te=SDL_CreateRGBSurfaceFrom((void *)hand,160,90,32,160*4,
	       0x00ff0000,0x0000ff00,0x000000ff,0);

	SDL_SetColorKey(te,SDL_SRCCOLORKEY,0x00ffffff);

	rectFore.x=1;
	rectFore.y=1;
	rectFore.w=450;
	rectFore.h=300;

	rectBack.x=0;
	rectBack.y=0;
	rectBack.w=450;
	rectBack.h=300;

	rectHand.x=0;
	rectHand.y=0;
	rectHand.w=160;
	rectHand.h=90;

	rectTe=rectHand;

	draw();

	while (quite==0) {

		SDL_WaitEvent(&e);

		switch (e.type) {

		case SDL_MOUSEMOTION:

			hx=e.motion.x;
			hy=e.motion.y;

			rectHand.x=hx-80;
			rectHand.y=hy-45;
			draw();

			if (hx<rectFore.x || hx>=rectFore.x+rectFore.w ||
			    hy<rectFore.y || hy>=rectFore.y+rectFore.h)
				SDL_ShowCursor(SDL_ENABLE);
			else
				SDL_ShowCursor(SDL_DISABLE);

			break;

		case SDL_QUIT:

			quite=1;
			break;

		}

	}

	SDL_FreeSurface(back);
	SDL_FreeSurface(te);

	SDL_Quit();

	return 0;

}
